C **********************************************************************  
C **********************************************************************  
C PROGRAMMA PER LA SOLUZIONE DI PROBLEMI PIANI
      PROGRAM PLANE_ELEMENTS
C **********************************************************************  
C **********************************************************************  
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'COMMON.H'
C
      CALL OPEN_FILES  
C
      CALL INPUT
C
      WRITE(*,*)' '
      WRITE(*,*)'..... SOLUZIONE ......NEQ=', NNODI*2
C
      CALL STIFFNESS
C
      CALL NODAL_FORCES
C
      CALL BOUNDARY_CONDITIONS
C
      CALL SOLVE(MAXEQ, XKG, NNODI*2, F, 1, DETERM, ISING, IUTIL)
C
      CALL OUTPUT
C
      END
C **********************************************************************  
C **********************************************************************  
C **********************************************************************  
C
C
C	    
C
C
C **********************************************************************  
      SUBROUTINE OPEN_FILES
C **********************************************************************  
      INCLUDE 'COMMON.H'
C
      WRITE(*,*)'******************************************************' 
      WRITE(*,*)'*                                                    *'
      WRITE(*,*)'*                 PLANE  STRUCTURES                  *'
      WRITE(*,*)'*                ===================                 *'
      WRITE(*,*)'*              ELEMENTS WITH  3, 4 NODES             *'
      WRITE(*,*)'******************************************************' 
      WRITE(*,*)' '
      WRITE(*,*)' '
C
1000  FORMAT(A)
1001  FORMAT(1X,A,$)
C
      PRINT 1001,' TYPE INPUT FILE NAME     > '
      READ(NFVIDEO,1000) FNAME_INP
      CALL EFFLST (FNAME_INP,LFI)
      WRITE(*,*)' '  
C      
      PRINT 1001,' TYPE OUTPUT FILE NAME    > '
      READ(NFVIDEO,1000)FNAME_OUT
      CALL EFFLST (FNAME_OUT,LFO)
      WRITE(*,*)' '
C ----------------------------------------------------------------------     
C INPUT FORMATTED FILE 
      OPEN (NFINP,FILE=FNAME_INP(1:LFI),STATUS='OLD',IOSTAT=IO)
      IF(IO.NE.0 ) THEN
       PRINT *,' FILE '//FNAME_INP(1:LFI)//' NON APRIBILE '
      ENDIF
C 
C OUTPUT FORMATTED FILE       
      OPEN (NFOUT,FILE=FNAME_OUT(1:LFO),STATUS='UNKNOWN',IOSTAT=IO)
      IF(IO.NE.0 ) THEN
       PRINT *,' FILE '//FNAME_OUT(1:LFO)//' NON APRIBILE '
      ENDIF 
C ----------------------------------------------------------------------
C BINARY FILE FOR THE STORAGE OF THE MATRIX [B] 
      OPEN (NF_B,FORM='UNFORMATTED',STATUS='SCRATCH')
      REWIND(NF_B )
C  
C BINARY FILE FOR THE STORAGE OF THE MATRIX [C][B] 
      OPEN (NF_CB,FORM='UNFORMATTED',STATUS='SCRATCH')
      REWIND(NF_CB)
C ----------------------------------------------------------------------
      RETURN
      END
C **********************************************************************  
C
C
C
C
C **********************************************************************      
      SUBROUTINE EFFLST ( STRING, LG)
C  REL 4.3 -
C  RETURNS THE EFFECTIVE LENGTH OF A STRING (W/O ALL THE TRAILING BLNKS)
C **********************************************************************
      CHARACTER *(*) STRING 
      LEFMAX = LEN (STRING)
      LG = LEFMAX
       DO 67 K=LEFMAX,1,-1
         IF ( STRING (K:K).EQ.' ') THEN
          LG = LG-1
         ELSE
          GOTO 68
         ENDIF  
67     CONTINUE
C 
68     RETURN 
       END
C **********************************************************************
C
C
C
C
C **********************************************************************  
C SUBROUTINE PER LA LETTURA DEI DATI DEL PROBLEMA
      SUBROUTINE INPUT
C **********************************************************************  
      IMPLICIT REAL*8(A-H,O-Z)
      INCLUDE 'COMMON.H'
C ----------------------------------------------------------------------
C TITLE
      READ(NFINP,'(A72)') TITLE
C ----------------------------------------------------------------------
C 1. LETTURA COORDINATE NODI
      READ(NFINP,'(A72)') STRINGA
	  READ(NFINP,*) NNODI
C
      DO 1 I=1,NNODI
      READ(NFINP,*) NNODO, X, Y ,Z
C
      XYZ(1,NNODO)=X
      XYZ(2,NNODO)=Y
      XYZ(3,NNODO)=Z
1     CONTINUE
      WRITE(*,*)'LETTO NODI', NNODI
C ----------------------------------------------------------------------
C AZZERO MATRICE INCIDENZE
      DO 15 II=1,MAXELE
      DO 16 JJ=1,5
16	 INC(JJ,II)=0
15    CONTINUE
C
C 2. LETTURA ELEMENTI
      READ(NFINP,'(A72)') STRINGA
      READ(NFINP,*) NELE
C
C ---------------------------
C SE ITYPE=3 ELEM TRIANGOLARE
C SE ITYPE=4 ELEM A 4 NODI
C
      NUM_MAT=0
	  DO 2 IEL=1,NELE
	  READ(NFINP,*) NE, ITYPE, NMAT, NPG
C
        IF(ITYPE.NE.3.AND.ITYPE.NE.4) THEN
	  WRITE(*,*)'ATTENZIONE, TIPO ELEMENTO NON PREVISTO',NE
	  STOP
	  ENDIF
C
	  NUM_MAT=MAX(NUM_MAT,NMAT)
C
        IF(ITYPE.EQ.3) THEN
	  READ(NFINP,*) N1, N2, N3
        INC(1,NE)=N1
	  INC(2,NE)=N2
	  INC(3,NE)=N3
	  IMAT(NE) =NMAT
	  NP_G(NE) =NPG
	  ITE(NE)  =ITYPE
	  ENDIF
C
	  IF(ITYPE.EQ.4) THEN
	  READ(NFINP,*) N1, N2, N3, N4
	  INC(1,NE)=N1
	  INC(2,NE)=N2
	  INC(3,NE)=N3
	  INC(4,NE)=N4
	  INC(5,NE)=NPG
	  IMAT(NE) =NMAT
 	  NP_G(NE) =NPG
	  ITE (NE) =ITYPE
        ENDIF
C
2     CONTINUE
      WRITE(*,*)'LETTO EL', NELE
C ----------------------------------------------------------------------
C 3. LETTURA DATI DEI MATERIALI
      READ(NFINP,'(A72)') STRINGA
C
C NPL=1 STATO TENSIONALE PIANO
C NPL=2 STATO DEFORMATIVO PIANO
C NPL=3 STATO ASSIALSIMMETRICO
C
	  DO 3 I=1,NUM_MAT
	   READ(NFINP,*) NM, NPL, E, XNI, DENS, SPESS
	   PROP(1,NM)=E
	   PROP(2,NM)=XNI
	   PROP(3,NM)=DENS
	   PROP(4,NM)=SPESS
	   I_PL(NM)  =NPL
3       CONTINUE
      WRITE(*,*)'LETTO MAT', NUM_MAT
C ----------------------------------------------------------------------
C 4. LETTURA CONDIZIONI DI VINCOLO
      READ(NFINP,'(A72)') STRINGA
C
C ITV=1 CEDIM IMPOSTO
C ITV=2 VINCOLO ELASTICO
C
C INIZIALIZZO LE MATRICI DEI VINCOLI (SE CEDIM()=-9999 -> DOF LIBERO)
      DO 12 II=1,NNODI
	  CEDIM(1,II)=-9999.
	  CEDIM(2,II)=-9999.
        RIGID(1,II)=0.0
        RIGID(2,II)=0.0
12    CONTINUE
C
	  READ(NFINP,*) NNODI_VINC
c
	  DO 4 I=1,NNODI_VINC
	  READ(NFINP,*) NNV, ITV 
C      
C ICODX, ICODY = 1 CEDIM IMPOSTO, =0  DOF LIBERO
	  IF(ITV.EQ.1) THEN
	  READ(NFINP,*) ICODVX, ICODVY,   DELTAX, DELTAY
	  IF(ICODVX.EQ.1) CEDIM(1,NNV)=DELTAX
	  IF(ICODVY.EQ.1) CEDIM(2,NNV)=DELTAY
        ENDIF
C
	  IF(ITV.EQ.2) THEN
	  READ(NFINP,*) RIGX, RIGY
	  RIGID(1,NNV)=RIGX
	  RIGID(2,NNV)=RIGY
        ENDIF      
4       CONTINUE
      WRITE(*,*)'LETTO VINC',NNODI_VINC
C ----------------------------------------------------------------------
C 5. LETTURA FORZE NODALI
      READ(NFINP,'(A72)') STRINGA
C
C AZZERO VETTORE FORZE NODALI
      DO 80 II=1,NNODI
      FORZE(1,II)=0.0D0
80    FORZE(2,II)=0.0D0
C
	  READ(NFINP,*) NNODI_CARICATI
	  DO 5 I=1, NNODI_CARICATI
	  READ(NFINP,*) NNC, FX, FY
	  FORZE(1,NNC)=FX
	  FORZE(2,NNC)=FY
5     CONTINUE
      WRITE(*,*)'LETTO FORZE',NNODI_CARICATI
C ----------------------------------------------------------------------
C 6. LETTURA FORZE DI MASSA
      READ(NFINP,'(A72)') STRINGA
C
      READ(NFINP,*) ACC, VX, VY
C
      VMOD=DSQRT(VX**2.+VY**2.)
	VX=VX/VMOD
	VY=VY/VMOD
C
      AX=ACC*VX
	AY=ACC*VY
C		
      WRITE(*,*)'LETTO FORZE INERZIALI'
C ----------------------------------------------------------------------
      RETURN
      END
C **********************************************************************  
C
C
C
C **********************************************************************  
C SUBROUTINE PER IL CALCOLO DELLE MATRICI DI RIGIDEZZA
      SUBROUTINE STIFFNESS
C **********************************************************************  
      IMPLICIT REAL*8(A-H,O-Z)
	INCLUDE 'COMMON.H'
C
C AZZERO LA MATRICE DI RIGIDEZZA GLOBALE
      DO 500 I=1,MAXEQ
	DO 501 J=1,MAXEQ
      XKG (I,J)=0.0D0
501   CONTINUE
500   CONTINUE
C ----------------------------------------------------------------------
      DO 1 IE=1,NELE
	 NM=IMAT(IE)
C	
       CALL C_ELASTICA(NM)
C   
C AZZERAMENTO MATRICE RIGIDEZZA EL. CORRENTE IE
       DO 2 II=1,8
	 DO 2 JJ=1,8
2      XK(II,JJ)=0.0D0
C
       IF(ITE(IE).EQ.3) CALL STIFF_3NODI(IE)
	 IF(ITE(IE).EQ.4) CALL STIFF_4NODI(IE)
C
	 CALL ASSEMBLAGGIO(IE,ITE(IE))
C	
1     CONTINUE
C ----------------------------------------------------------------------
      RETURN
	END
C **********************************************************************  
C
C
C
C **********************************************************************  
C MATERIALS ELASTICITY MATRIX
      SUBROUTINE C_ELASTICA(NM_)
C **********************************************************************  
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
C ----------------------------------------------------------------------
C ITC=1 STATO TENSIONALE PIANO
C ITC=2 STATO DEFORMATIVO PIANO
C ITC=3 STATO ASSIALSIMMETRICO
c
      ITC=I_PL(NM_)
	E  =PROP(1,NM_)
	ENU=PROP(2,NM_)
C
	IF(ITC.EQ.1) GOTO 1000
      IF(ITC.EQ.2) GOTO 2000
      IF(ITC.EQ.3) GOTO 3000
C ---------------------------------------------------------------------- 
C ---------------------------------------------------------------------- 
C 1 - PLANE STRESS - ISOTROPIC MATERIAL
1000  CONTINUE
C
C                        E   | 1   V   0  |
C               [C] =  ----- | V   1   0  |
C                      1-V*V | 0   0  1-V |
C                            |        --- |
C                                      2
	C(1,1)=1.D0 
      C(1,2)=ENU 
      C(1,3)=0.0D0
      C(2,1)=ENU  
      C(2,2)=1.D0 
      C(2,3)=0.D0
      C(3,1)=0.D0
      C(3,2)=0.D0
      C(3,3)=(1.D0-ENU)/2.D0 
      TEMP=E/(1.D0-ENU**2.D0) 
C
      DO 18 II=1,3
	DO 19 JJ=1,3
      C(II,JJ)=C(II,JJ)*TEMP
19    CONTINUE
18    CONTINUE
C
      RETURN
C ---------------------------------------------------------------------- 
C ---------------------------------------------------------------------- 
C 2 - PLANE STRAIN - ISOTROPIC MATERIAL
2000  CONTINUE 
C
C     | SX |                       | 1-V      V      0   ... | | EX |
C     |    |                       |                         | |    | 
C     | SY |                E      | V       1-V     0   ... | | EY |
C     |    | =[C]{E}=  ----------- |                         | |    |
C     |TXY |           (1+V)(1-2V) |  0     0    1-2V    ... | | GXY|
C     |    |                       |             ----        | |    |
C     |(SZ)|                       |              2      ... | | EZ |
C                                  | ...   ...   ...     ... | |    |        
        C(1,1)= 1.0D0-ENU  
        C(1,2)= ENU        
        C(1,3)= 0.0D0
        C(2,1)= ENU        
        C(2,2)=(1.0D0-ENU)
        C(2,3)= 0.0D0
        C(3,1)= 0.0D0
        C(3,2)= 0.0D0
        C(3,3)=(1.0D0-2.0D0*ENU)/2.0D0 
        TEMP  = E /((1.0D0+ENU  )*(1.D0-2.0D0*ENU  ))  
C 
      DO 13 II=1,3
	DO 11 JJ=1,3
      C(II,JJ)=C(II,JJ)*TEMP
11    CONTINUE
13    CONTINUE
C
      RETURN
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------      
C 3 - AXIALSYMMETRY (MATERIALE ISOTROPO EL. LINEARE)
3000  CONTINUE
C                                |  1        V/(1-V)   0       V/(1-V) |
C                       E(1-V)   |  V/(1-V)  1         0       V/(1-V) |
C              [C] =  ---------- |  0        0     1-2V/(2-2V) 0       |
C                    (1+V)(1-2V) |                                     |
C                                |  V/(1-V)  V/(1-V)   0       1       |
C ORDINE DELLE TENSIONI E DEF.                                
C 1 SIGMA R       EPS R
C 2 SIGMA Z       EPS Z
C 3 TAU RZ        GAMMA RZ
C 4 SIGMA THETA   EPS THETA
C
C ----------------------------------------------------------------------
C 
       C(1,1)=1.0D0         
       C(1,2)=ENU/(1.D0-ENU) 
       C(1,3)=0.D0        
       C(1,4)=ENU/(1.D0-ENU) 
C               
       C(2,1)=ENU/(1.D0-ENU) 
       C(2,2)=1.0D0          
       C(2,3)=0.0D0
       C(2,4)=ENU/(1.D0-ENU) 
C              
       C(3,1)=0.0D0
       C(3,2)=0.0D0
       C(3,3)=(1.0D0-2.D0*ENU  )/(2.D0*(1.D0-ENU  )) 
       C(3,4)=0.0D0   
C            
       C(4,1)=ENU/(1.D0-ENU)  
       C(4,2)=ENU/(1.D0-ENU)   
       C(4,3)=0.0D0        
       C(4,4)=1.0D0      
C
       TEMP= E *(1.D0-ENU  )/((1.D0+ENU  )*(1.D0-2.D0*ENU  )) 
C      
      DO 12 II=1,4
	DO 12 JJ=1,4
12    C(II,JJ)=C(II,JJ)*TEMP
C ----------------------------------------------------------------------
      RETURN
C ----------------------------------------------------------------------
      END
C **********************************************************************
C
C
C
C
C **********************************************************************
C SUBROUTINE PER CALCOLO MATRICE DI RIGID ELEM A 3 NODI
      SUBROUTINE STIFF_3NODI(IE)
C **********************************************************************
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
C ----------------------------------------------------------------------
C STABILISCO NUMERO TENSIONI PER L'ELEMENTO CORRENTE (IN BASE AL TIPO DI
C PROBLEMA ELASTICO)
      NMAT=IMAT(IE) 
      IPL_STR=I_PL(NMAT)
C
      NTENS=4
      IF(IPL_STR.EQ.1.OR.IPL_STR.EQ.2) NTENS=3
C
      N1=INC(1,IE)
      N2=INC(2,IE)
      N3=INC(3,IE)
C
C COORD 1 NODO
	  X1=XYZ(1,N1)
	  Y1=XYZ(2,N1)
	  Z1=XYZ(3,N1)
C
C COORD 2 NODO
	  X2=XYZ(1,N2)
	  Y2=XYZ(2,N2)
	  Z2=XYZ(3,N2)
C
C COORD 3 NODO
	  X3=XYZ(1,N3)
	  Y3=XYZ(2,N3)
	  Z3=XYZ(3,N3)
C
C COORD CENTRO ELEMENTO
      XM =(X1+X2+X3)/3.0D0
      YM =(Y1+Y2+Y3)/3.0D0
      ZM =(Z1+Z2+Z3)/3.0D0
C
C NEL CASO DI ASSIALSIMMETRIA IL RAGGIO=COORD X
	RPG=XM
C ----------------------------------------------------------------------
      CALL A_TRIA(X1,Y1,Z1, X2,Y2,Z2, X3,Y3,Z3, ATR ) 
C
C AREE TRIANGOLI INTERNI
      CALL A_TRIA(XM,YM,ZM, X2,Y2,Z2, X3,Y3,Z3, A1 ) 
      CALL A_TRIA(XM,YM,ZM, X1,Y1,Z1, X3,Y3,Z3, A2 ) 
      CALL A_TRIA(XM,YM,ZM, X1,Y1,Z1, X2,Y2,Z2, A3 )
C
C SHAPE FUNCTS 
        FF1=A1/ATR
        FF2=A2/ATR
        FF3=A3/ATR
C ----------------------------------------------------------------------
C SPESSORE EL
      PI=DACOS(-1.0D0)
      T=PROP(4, IMAT(IE))
      IF(IPL_STR.EQ.2) T=1.0D0
      IF(IPL_STR.EQ.3) T=2.D0*PI*RPG
C
      AREA_EL(IE)= ATR
	VOL_EL(IE) = ATR*T
C
C AZZERO MATRICE DI COMPATIBILITA' PG CORRENTE
      DO 2 J=1,NTENS
	DO 3 K=1,6
	 B(J,K)=0.0D0
3     CONTINUE
2     CONTINUE
C
C CALCOLO MATRICE DI COMPATIBILITA' B	(EQ. (6.116), CAP. 6 LIBRO)
	B(1,1)=(Y2-Y3)/(2.*ATR)
	B(1,3)=(Y3-Y1)/(2.*ATR)
	B(1,5)=(Y1-Y2)/(2.*ATR)
C
      B(2,2)=(X3-X2)/(2.*ATR)
	B(2,4)=(X1-X3)/(2.*ATR)
	B(2,6)=(X2-X1)/(2.*ATR)
C
      B(3,1)=(X3-X2)/(2.*ATR)
	B(3,2)=(Y2-Y3)/(2.*ATR)
	B(3,3)=(X1-X3)/(2.*ATR)
	B(3,4)=(Y3-Y1)/(2.*ATR)
	B(3,5)=(X2-X1)/(2.*ATR)
	B(3,6)=(Y1-Y2)/(2.*ATR)
C
C AXIALSIMM. (EQ. (6.105) )  
      IF(IPL_STR.EQ.3) THEN 
       B(4,1)= FF1/RPG
       B(4,2)= 0.0D0
       B(4,3)= FF2/RPG
       B(4,4)= 0.0D0
       B(4,5)= FF3/RPG
       B(4,6)= 0.0D0           
      ENDIF
C ------------------
C CALCOLO C*B
      DO 4 I=1,NTENS
	  DO 5 J=1,6
	  TEMP=0.0D0
	   DO 6 K=1,NTENS
	   TEMP=TEMP+C(I,K)*B(K,J)
6        CONTINUE
        CB(I,J)=TEMP
5       CONTINUE
4     CONTINUE
C
C ----------------------------------------------------------------------
C SCRIVO LE MATRICI B E CB SU FILE BINARIO PER USO SUCCESSIVO
      WRITE(NF_B ) ((B (I,J),J=1,6 ),I=1,NTENS) 	 
      WRITE(NF_CB) ((CB(I,J),J=1,6 ),I=1,NTENS)
C
C ----------------------------------------------------------------------
C
C CALCOLO LA MATRICE DI RIGIDEZZA DELL'ELEMENTO
	DO 7 I=1,6
	DO 8 J=1,6
	  TEMP=0.0D0
	  DO 9 K=1,NTENS
	  TEMP=TEMP+B(K,I)*CB(K,J)
9       CONTINUE
        XK(I,J)=ATR*T*TEMP
8     CONTINUE
7     CONTINUE
C ----------------------------------------------------------------------
	  RETURN
	  END
C **********************************************************************
C
C
C
C
C **********************************************************************  
C ATR: AREA OF A TRIANGLE BY KNOWING ITS VERTEX COORDINATES
        SUBROUTINE A_TRIA(X1,Y1,Z1, X2,Y2,Z2, X3,Y3,Z3, ATR )           
C **********************************************************************  
        IMPLICIT REAL*8(A-H,O-Z)
C ----------------------------------------------------------------------
        A1 = X1*Y2 + X2*Y3 + Y1*X3 - Y2*X3 - X1*Y3 - Y1*X2 
        A2 = Y1*Z2 + Y2*Z3 + Z1*Y3 - Z2*Y3 - Y1*Z3 - Z1*Y2  
        A3 = Z1*X2 + Z2*X3 + X1*Z3 - X2*Z3 - Z1*X3 - X1*Z2 
C
        ATR= 0.5D0*DSQRT(DABS(A1**2.0D0+A2**2.0D0+A3**2.0D0) )
C ----------------------------------------------------------------------
      RETURN
      END
C ********************************************************************** 
C
C
C
C
C **********************************************************************
      SUBROUTINE STIFF_4NODI(IE)
C **********************************************************************
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
      DIMENSION XYE(3,4), XJ(2,2) , XJT(2,2), XI(2,2)                 
C ----------------------------------------------------------------------  
C DETERMINO NUMERO TENSIONI PER L'ELEMENTO CORRENTE
      PI=DACOS(-1.0D0)
	NMAT=IMAT(IE) 
      IPL_STR=I_PL(NMAT)
C
C DETERMINO NUMERO TENSIONI DEL PROBLEMA
      NTENS=4
      IF(IPL_STR.EQ.1.OR.IPL_STR.EQ.2) NTENS=3
C
C IPL_STR=1 STATO TENSIONALE PIANO
C IPL_STR=2 STATO DEFORMATIVO PIANO
C IPL_STR=3 STATO ASSIALSIMMETRICO
C SPESSORE EL
	T=PROP(4, IMAT(IE))
      IF(IPL_STR.EQ.2) T=1.0D0
C
C ESTRAGGO COORDINATE GLOBALI NODI DELL'ELEMENTO       
       XYE(1,1)=XYZ(1,INC(1,IE))
       XYE(2,1)=XYZ(2,INC(1,IE))
       XYE(3,1)=XYZ(3,INC(1,IE))
C
       XYE(1,2)=XYZ(1,INC(2,IE))
       XYE(2,2)=XYZ(2,INC(2,IE))
       XYE(3,2)=XYZ(3,INC(2,IE))
C
       XYE(1,3)=XYZ(1,INC(3,IE))
       XYE(2,3)=XYZ(2,INC(3,IE))
       XYE(3,3)=XYZ(3,INC(3,IE))
C
       XYE(1,4)=XYZ(1,INC(4,IE))
       XYE(2,4)=XYZ(2,INC(4,IE))
       XYE(3,4)=XYZ(3,INC(4,IE))
C ----------------------------
C DETERMINO COORD E PESI PER I PUNTI DI GAUSS EL IE
      NPG=NP_G(IE)
C      
      CALL GAULEG(-1.D0, +1.D0, XG, WG, NPG) 
C
      AREA   =0.0D0
	VOLUME =0.0D0
C
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C CICLO SUI PUNTI DI GAUSS PER L'INTEGRAZIONE	NUMERICA DI K
      DO 10 ICSI=1,NPG
	CSI=XG(ICSI)
C
      DO 21 IETA=1,NPG
      ETA=XG(IETA)
C
      CALL FUNZ_FORMA(CSI, ETA )
C										    
C COORDINATE ASSOLUTE P.TO DI GAUSS                
         XPI=0.0D0
         YPI=0.0D0
         ZPI=0.0D0        
         DO 28 KK=1,4
         XPI=XPI+XN(KK)*XYE(1,KK) 
         YPI=YPI+XN(KK)*XYE(2,KK)
28       ZPI=ZPI+XN(KK)*XYE(3,KK)
C
C RAGGIO NEL CASO ASSIALSIMMETRICO
         RPG=XPI    
C
C CALCOLO LA MATRICE JACOBIANA
      TEMP=0.0D0
      DO 50 J=1,4
50	TEMP=TEMP+ DXN(1,J)*XYE(1,J)
      XJ(1,1)=TEMP
C
      TEMP=0.0D0
      DO 51 J=1,4
51    TEMP=TEMP+ DXN(1,J)*XYE(2,J)
      XJ(1,2)=TEMP
C
      TEMP=0.0D0
      DO 52 J=1,4
52	TEMP=TEMP+ DXN(2,J)*XYE(1,J)
      XJ(2,1)=TEMP
C
      TEMP=0.0D0
      DO 53 J=1,4
53	TEMP=TEMP+ DXN(2,J)*XYE(2,J)
      XJ(2,2)=TEMP
C
      DETJ=XJ(1,1)*XJ(2,2)-XJ(1,2)*XJ(2,1)
C
      DETI=1.0D0/DETJ
C
C      XJT(1,1)=XJ(1,1)
C      XJT(1,2)=XJ(1,2)
C      XJT(2,2)=XJ(2,2)
C      XJT(2,1)=XJ(2,1)
C
C CALCOLO J-1           
      TEMP    = XJ(1,1) 
      XJ(1,1) = XJ(2,2)*DETI 
      XJ(2,2) = TEMP   *DETI 
      XJ(1,2) =-XJ(1,2)*DETI 
      XJ(2,1) =-XJ(2,1)*DETI 
C
C ----------------------------------------------------------------------
C CALCOLO DERIVATE ASSOLUTE FUNZ FORMA    
C
	DO 30 II=1,4
C
      DERXY(1,II)=XJ(1,1)*DXN(1,II)+XJ(1,2)*DXN(2,II)
      DERXY(2,II)=XJ(2,1)*DXN(1,II)+XJ(2,2)*DXN(2,II)
C
30    CONTINUE
C ----------------------------------------------------------------------
C --- FORMAZIONE MATRICE [B]  --> {EPS} = [B]{D}  
C 
         DO 39 I1=1,4
         DO 40 J1=1,8
40       B(I1,J1)=0.0D0
39       CONTINUE
C
         DO 35 I1=1,4
         B(1,2*I1-1)=DERXY(1,I1)
         B(2,2*I1  )=DERXY(2,I1)
         B(3,2*I1-1)=DERXY(2,I1)
35       B(3,2*I1  )=DERXY(1,I1)
C
C AXIALSIMM.  
         IF(IPL_STR.EQ.3) THEN
         DO 36 I1=1,4
         B(4,2*I1-1)=XN(I1)/RPG
36       B(4,2*I1  )=0.0D0
C
         T=2.0D0*PI*RPG         
	   ENDIF
C ----------------------------------------------------------------------
C --- FORMAZIONE MATRICE [CB]  --> {SIG} = [CB]{D}
C ----------------------------------
         DO 218 I1=1,NTENS
         DO 217 I2=1,8
          TERM=0.0D0
          DO 316 K1=1,NTENS
316       TERM=TERM+C(I1,K1)*B(K1,I2)
          CB(I1,I2)= TERM
217      CONTINUE
218      CONTINUE
C        
C ----------------------------------------------------------------------
C SCRIVO SUL FILE LA MATRICI B E CB PER USO SUCCESSIVO
C    
          WRITE(NF_B ) (( B (I7,I8),I8=1,8 ),I7=1,NTENS)     
          WRITE(NF_CB) ((CB (I7,I8),I8=1,8 ),I7=1,NTENS)     
C 
C ----------------------------------------------------------------------
C --- DET E` IL DETERM. DI [J] ---> MOLTIPLICO ANCHE PER I PESI WG
      DETWG=DETJ*WG(ICSI)*WG(IETA)
C
	AREA=AREA+DETWG
C         
      VOLUME=VOLUME+DETWG*T
C
         DO 34 I1=1,8
         DO 33 I2=1,8
            TERM=0.0D0
            DO 32 J1=1,NTENS
            DO 38 J2=1,NTENS  
38          TERM=TERM+B(J1,I1)*C(J1,J2)*B(J2,I2)
32          CONTINUE
            XK(I1,I2)=XK(I1,I2)+TERM*DETWG*T
33       CONTINUE
34       CONTINUE
C
C ------------
21    CONTINUE
10    CONTINUE
C FINE CICLI SUI PUNTI DI GAUSS
C ----------------------------------------------------------------------
      AREA_EL(IE)=AREA
	VOL_EL (IE)=VOLUME
C ----------------------------------------------------------------------
      RETURN
	END
C ********************************************************************** 
C
C
C
C
C
C **********************************************************************  
C CALCOLO VALORE FUNZ FORMA E LORO DERIVATE LOCALI
      SUBROUTINE FUNZ_FORMA(CSI, ETA)
C **********************************************************************  
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
C ----------------------------------------------------------------------
      XN(1)=0.25D0*(1.D0-CSI)*(1.D0-ETA)
         DXN(1,1)=-0.25D0*(1.D0-ETA)
	   DXN(2,1)=-0.25D0*(1.D0-CSI)
C
      XN(2)=0.25D0*(1.D0+CSI)*(1.D0-ETA)
         DXN(1,2)=+0.25D0*(1.D0-ETA)
	   DXN(2,2)=-0.25D0*(1.D0+CSI)
C
      XN(3)=0.25D0*(1.D0+CSI)*(1.D0+ETA)
         DXN(1,3)=+0.25D0*(1.D0+ETA)
	   DXN(2,3)=+0.25D0*(1.D0+CSI)
C
      XN(4)=0.25D0*(1.D0-CSI)*(1.D0+ETA)
         DXN(1,4)=-0.25D0*(1.D0+ETA)
	   DXN(2,4)=+0.25D0*(1.D0-CSI)
C ----------------------------------------------------------------------
      RETURN
	END
C **********************************************************************  
C
C
C
C
C **********************************************************************  
C  S U B R O U T I N E     C A L C O L O     P A R A M E T R I
C  D I      I N T E G R A Z I O N E
C  G A U S S  ---  L E G E N D R E
C    
      SUBROUTINE GAULEG(X1,X2,X,W,N)
C **********************************************************************  
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION X(N),W(N)
      PARAMETER (EPS=3.D-14)
      PI=DACOS(-1.0D0)
      M=(N+1)/2
      XM=0.5D0*(X2+X1)
      XL=0.5D0*(X2-X1)
      DO 12 I=1,M
        Z=COS(PI*(I-.25D0)/(N+.5D0))
1       CONTINUE
          P1=1.D0
          P2=0.D0
          DO 11 J=1,N
            P3=P2
            P2=P1
            P1=((2.D0*J-1.D0)*Z*P2-(J-1.D0)*P3)/J
11        CONTINUE
          PP=N*(Z*P1-P2)/(Z*Z-1.D0)
          Z1=Z
          Z=Z1-P1/PP
        IF(ABS(Z-Z1).GT.EPS)GO TO 1
        X(I)=XM-XL*Z
        X(N+1-I)=XM+XL*Z
        W(I)=2.D0*XL/((1.D0-Z*Z)*PP*PP)
        W(N+1-I)=W(I)
12    CONTINUE
      RETURN
      END
C ********************************************************************** 
C
C
C
C
C **********************************************************************
      SUBROUTINE ASSEMBLAGGIO(IEL, ITIPOEL)
C **********************************************************************
C ----------------------------------------------------------------------      
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
      DIMENSION NN(4), IS(4) 
C ----------------------------------------------------------------------  
C INCIDENZE ELEMENTO CORRENTE IEL
      NN(1)=INC(1,IEL)
      NN(2)=INC(2,IEL)
      NN(3)=INC(3,IEL)
      NN(4)=INC(4,IEL)
C
      NNOD=4
      IF(ITIPOEL.EQ.3) NNOD=3
C
C --- ASSEMBLAGGIO MATRICE GLOBALE DELLA STRUTTURA [XKG]
C
        N1=INC(1,IEL)
        N2=INC(2,IEL)
        N3=INC(3,IEL)
        N4=INC(4,IEL)
C
        IS(1)=2*(N1-1)
        IS(2)=2*(N2-1)
        IS(3)=2*(N3-1)
        IS(4)=2*(N4-1)
C -------------------------
           DO 860 JJ=1,NNOD
           IB=2*(JJ-1)
           DO 860 II=1,NNOD
             IA=2*(II-1)
             DO 203 I=1,2
             DO 204 J=1,2
C
         XKG(IS(II)+I,IS(JJ)+J)=XKG(IS(II)+I,IS(JJ)+J)+XK(I+IA,J+IB)
C
204           CONTINUE
203          CONTINUE
860        CONTINUE
C ----------------------------------------------------------------------
      RETURN
C ----------------------------------------------------------------------
      END
C **********************************************************************
C
C
C
C
C
C **********************************************************************
      SUBROUTINE NODAL_FORCES
C ----------------------------------------------------------------------      
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
C ----------------------------------------------------------------------            
C AZZERO IL VETTORE DELLE FORZE NODALI
      DO 5 J=1,NNODI*2
5	F(J)=0.0D0
C ----------------------------------------------------------------------
      DO 1 I=1,NNODI
C
      FX=FORZE(1,I)
	FY=FORZE(2,I)
C
      IF(FX.NE.0.0D0.OR.FY.NE.0.0D0) THEN 
       NEQX=I*2-1
	 NEQY=I*2
C
       F(NEQX)=F(NEQX)+FX
       F(NEQY)=F(NEQY)+FY
	ENDIF
C
1     CONTINUE
C ----------------------------------------------------------------------
C FORZE INERZIALI
C
      DO 2 IE=1,NELE
	IF(ITE(IE).EQ.3) NNOD=3
	IF(ITE(IE).EQ.4) NNOD=4
C
	NM=IMAT(IE)
	DENS=PROP(3,NM)
C
	 F_IN_X=DENS*VOL_EL(IE) * AX
	 F_IN_Y=DENS*VOL_EL(IE) * AY

	 F_IN_X_NODO=F_IN_X/NNOD
	 F_IN_Y_NODO=F_IN_Y/NNOD
C
	N1=INC(1,IE)
	N2=INC(2,IE)
	N3=INC(3,IE)
	N4=INC(4,IE)
C
	NEQX1=2*N1-1
	NEQX2=2*N2-1
	NEQX3=2*N3-1
	NEQX4=2*N4-1
C
	NEQY1=2*N1
	NEQY2=2*N2
	NEQY3=2*N3
	NEQY4=2*N4
C
      F(NEQX1)=F(NEQX1)+F_IN_X_NODO
      F(NEQX2)=F(NEQX2)+F_IN_X_NODO
      F(NEQX3)=F(NEQX3)+F_IN_X_NODO
C
      F(NEQY1)=F(NEQY1)+F_IN_Y_NODO
      F(NEQY2)=F(NEQY2)+F_IN_Y_NODO
      F(NEQY3)=F(NEQY3)+F_IN_Y_NODO
      				  
	IF(ITE(IE).EQ.4) THEN
	F(NEQX4)=F(NEQX4)+F_IN_X_NODO
      F(NEQY4)=F(NEQY4)+F_IN_Y_NODO
	ENDIF
C
2     CONTINUE
C ----------------------------------------------------------------------
      RETURN
	END
C **********************************************************************
C
C
C
C
C
C **********************************************************************
      SUBROUTINE BOUNDARY_CONDITIONS
C ----------------------------------------------------------------------      
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
C ----------------------------------------------------------------------            
      DO 1 I=1,NNODI
C
      NEQX=2*I-1
      NEQY=2*I
C -----------------------------------
C 1. SPOSTAMENTI NOTI
C DIR X
	  IF(CEDIM(1,I).NE.-9999.) THEN
	  UX=CEDIM(1,I)
	  IF(UX.NE.0.0D0) THEN
	  XKG(NEQX,NEQX)=XKG(NEQX,NEQX)+STIFF
	  F(NEQX)=F(NEQX)+STIFF*UX
	  ELSE
        XKG(NEQX,NEQX)=XKG(NEQX,NEQX)+STIFF
	  ENDIF	
	  ENDIF
C
C DIR Y
	  IF(CEDIM(2,I).NE.-9999.) THEN
	  UY=CEDIM(2,I)
	  IF(UY.NE.0.0D0) THEN
	  XKG(NEQY,NEQY)=XKG(NEQY,NEQY)+STIFF
	  F(NEQY)=F(NEQY)+STIFF*UY
	  ELSE
        XKG(NEQY,NEQY)=XKG(NEQY,NEQY)+STIFF
	  ENDIF	
	  ENDIF
C
      GOTO 1
C ------------------------------------ 	
C 2. VINCOLI ELASTICI
C
	NEQX=2*I-1
	NEQY=2*I
C
C MOLLA IN DIREZIONE X
      IF(RIGID(1,I).NE.0.0D0) THEN
	XKG(NEQX,NEQX)=XKG(NEQX,NEQX)+ RIGID(1,I)
	ENDIF
C
C MOLLA IN DIREZIONE Y
      IF(RIGID(2,I).NE.0.0D0) THEN
	XKG(NEQY,NEQY)=XKG(NEQY,NEQY)+ RIGID(2,I)
	ENDIF
C
2     CONTINUE
C
C --------------------------------------	
1     CONTINUE
C ----------------------------------------------------------------------
      RETURN
      END
C **********************************************************************
C
C
C
C
C **********************************************************************  
      SUBROUTINE SOLVE(NDM,A,N,B,M,DETERM,ISING,INDEX_)
C **********************************************************************  
C --- INVERSE OR LINEAR EQUATION SOLVER
C
        DOUBLE PRECISION A,B,AMAX,T,SWAP,DETERM,PIVOT
        DIMENSION A(NDM,NDM), B(NDM,1),INDEX_(N,3)
        EQUIVALENCE (IROW,JROW), (ICOLUM,JCOLUM), (AMAX,T,SWAP)
C ----------------------------------------------------------------------
C        
        DETERM=1.0D0
        DO 10 J=1,N
10      INDEX_(J,3)=0
        DO 130 I=1,N
C
C SEARCH FOR PIVOT
        AMAX=0.0D0
        DO 40 J=1,N
        IF(INDEX_(J,3).EQ.1)GOTO 40
        DO 30 K=1,N
        IF(INDEX_(K,3)-1)20,30,190
20      IF(DABS(A(J,K)).LE.AMAX) GOTO 30
        IROW=J
        ICOLUM=K
        AMAX=DABS(A(J,K))
30      CONTINUE
40      CONTINUE
C
        INDEX_(ICOLUM,3)=INDEX_(ICOLUM,3)+1
        INDEX_(I,1)=IROW
        INDEX_(I,2)=ICOLUM
C
C ---INTERCHANGE ROWS TO PUT PIVOT ELEM.ON DIAGONAL
C
        IF(IROW.EQ.ICOLUM)GO TO 70
        DETERM=-DETERM
        DO 50 L=1,N
        SWAP=A(IROW,L)
        A(IROW,L)=A(ICOLUM,L)
50      A(ICOLUM,L)=SWAP
        IF(M.LE.0)GO TO 70
        DO 60 L=1,M
        SWAP=B(IROW,L)
        B(IROW,L)=B(ICOLUM,L)
60      B(ICOLUM,L)=SWAP
C
C DIVIDE PIVOT ROW BY PIVOT ELEM.
70      PIVOT=A(ICOLUM,ICOLUM)
c       DETERM=DETERM*PIVOT
        A(ICOLUM,ICOLUM)=1.0D0
C
        DO 80 L=1,N
80      A(ICOLUM,L)=A(ICOLUM,L)/PIVOT
        IF(M.LE.0)GO TO 100
        DO 90 L=1,M
90      B(ICOLUM,L)=B(ICOLUM,L)/PIVOT
C
C REDUCE NON PIVOT ROWS
100     DO 130 L1=1,N
        IF(L1.EQ.ICOLUM)GO TO 130
        T=A(L1,ICOLUM)
        A(L1,ICOLUM)=0.0D0
        DO 110 L=1,N
110     A(L1,L)=A(L1,L)-A(ICOLUM,L)*T
        IF(M.LE.0)GO TO 130
        DO 120 L=1,M
120     B(L1,L)=B(L1,L)-B(ICOLUM,L)*T
130     CONTINUE
C
C INTERCHANGE COLUMNS
C
        DO 150 I=1,N
        L=N+1-I
        IF(INDEX_(L,1).EQ.INDEX_(L,2))GO TO 150
        JROW=INDEX_(L,1)
        JCOLUM=INDEX_(L,2)
        DO 140 K=1,N
        SWAP=A(K,JROW)
        A(K,JROW)=A(K,JCOLUM)
        A(K,JCOLUM)=SWAP
140     CONTINUE
150     CONTINUE
        DO 170 K=1,N
        IF(INDEX_(K,3).EQ.1)GO TO 160
        ISING=2
        GO TO 180
160     CONTINUE
170     CONTINUE
        ISING=1
180     RETURN
190     ISING=2
C ----------------------------------------------------------------------
        RETURN
        END
C ********************************************************************** 
C
C
C
C
C **********************************************************************
      SUBROUTINE OUTPUT
C ----------------------------------------------------------------------      
      IMPLICIT REAL *8 (A-H,O-Z)
      INCLUDE 'COMMON.H'
      DIMENSION NN(4), DE(8), XYE(3,4) 
C ----------------------------------------------------------------------  
C ----------------------------------------------------------------------  
C     WRITE(NFOUT,*)TITLE
C
      WRITE(NFOUT,*)'================================================='
      WRITE(NFOUT,*)' '
      WRITE(NFOUT,*)'DATI DI INPUT'
      WRITE(NFOUT,*)'************* '
C ----------------------------------------------------------------------
C NODI
17    FORMAT(1I6,2X,3F14.3)
c     	
      WRITE(NFOUT,*)'NODI'
      WRITE(NFOUT,*)'---- '
      WRITE(NFOUT,*)'   N           X             Y             Z'
C
	DO 1 I=1,NNODI
      WRITE(NFOUT,17) I, XYZ(1,I), XYZ(2,I), XYZ(3,I)
1     CONTINUE
C
      WRITE(NFOUT,*)' '
C ----------------------------------------------------------------------
C ELEMENTI
10    FORMAT(1I4,2X, 3I6,3X, 2I3,3X, 2F13.4)     	
11    FORMAT(1I4,2X, 4I6,3X, 2I3,3X, 2F13.4) 
      WRITE(NFOUT,*)'ELEMENTI'
      WRITE(NFOUT,*)'-------- '
      WRITE(NFOUT,*)' NEL    N1    N2    N3    N4    N.MAT.  N.P.GAUSS
     &  AREA  VOLUME '
C
	DO 2 NE=1,NELE
      IF(INC(4,NE).EQ.0) THEN
      WRITE(NFOUT,10) NE, INC(1,NE),INC(2,NE),INC(3,NE),
     &                 IMAT(NE), NP_G(NE), 
     &                 AREA_EL(NE),VOL_EL(NE)
      ELSE
      WRITE(NFOUT,11) NE, INC(1,NE),INC(2,NE),INC(3,NE),INC(4,NE),
     &                 IMAT(NE), NP_G(NE), 
     &                 AREA_EL(NE),VOL_EL(NE)
      ENDIF
2     CONTINUE
      WRITE(NFOUT,*)' '
C ----------------------------------------------------------------------
C MATERIALI
12    FORMAT(1I4,2X,2E12.4,1X,1I3,1X,2E12.4)     	
      WRITE(NFOUT,*)'MATERIALI'
      WRITE(NFOUT,*)'--------- '							 
      WRITE(NFOUT,*)' NMAT    E       NU      PL.STR/STRA  DENS   THICK'
C
      DO 3 NM=1,NUM_MAT
      WRITE(NFOUT,12)NM, PROP(1,NM), PROP(2,NM), I_PL(NM), PROP(3,NM),
     &                   PROP(4,NM)
3     CONTINUE
C
      WRITE(NFOUT,*)' '
C ----------------------------------------------------------------------
C FORZE
13    FORMAT(1I4,2X,2E12.4)     	
      WRITE(NFOUT,*)'FORZE NODALI'
      WRITE(NFOUT,*)'------------ '
      WRITE(NFOUT,*)'NODO         FX          FY'
CCC
      DO 4 II=1,NNODI
      IF(FORZE(1,II).NE.0.0D0.OR.FORZE(2,II).NE.0.0D0)
     &WRITE(NFOUT,12) II, FORZE(1,II), FORZE(2,II)
4     CONTINUE
C
      WRITE(NFOUT,*)' '
C
c FORZE INERZIALI
      WRITE(NFOUT,*)'ACCELERAZIONE COMPONENTI X, Y'
      WRITE(NFOUT,*)'----------------------------- '
C
	WRITE(NFOUT,*) AX, AY
C ----------------------------------------------------------------------
C VINCOLI
14    FORMAT(1I4, 2X,1E12.4)     	
15    FORMAT(1I4, 8X,1E12.4)     	
16    FORMAT(1I4, 2X,2E12.4)     	
19    FORMAT(1I4,12X,1E12.4)     	
C
      WRITE(NFOUT,*)'VINCOLI'
      WRITE(NFOUT,*)'------- '
      WRITE(NFOUT,*)'NODO     UX          UY             KX      KY'
C
      DO 5 II=1,NNODI
C
C CEDIM IMPOSTI
       IF(CEDIM(1,II).NE.-9999.0.AND.CEDIM(2,II).NE.-9999.) THEN
        WRITE(NFOUT,16) II, CEDIM(1,II), CEDIM(2,II) 
       ENDIF
       IF(CEDIM(1,II).NE.-9999.0.AND.CEDIM(2,II).EQ.-9999.) THEN
        WRITE(NFOUT,14) II, CEDIM(1,II) 
       ENDIF
       IF(CEDIM(1,II).EQ.-9999.0.AND.CEDIM(2,II).NE.-9999.) THEN
        WRITE(NFOUT,15) II, CEDIM(2,II) 
       ENDIF
C
C VINCOLI ELASTICI
       IF(RIGID(1,II).NE.0.0.OR.RIGID(2,II).NE.0.) THEN
        WRITE(NFOUT,19) II, RIGID(1,II), RIGID(2,II)
       ENDIF
C ----------------------------------------------------------------------
5     CONTINUE
C
      WRITE(NFOUT,*)' '
C ----------------------------------------------------------------------
      WRITE(NFOUT,*)'================================================='
      WRITE(NFOUT,*)'================================================='
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
      WRITE(NFOUT,*)' '
      WRITE(NFOUT,*)' '
      WRITE(NFOUT,*)' '
      WRITE(NFOUT,*)'RISULTATI ANALISI'
      WRITE(NFOUT,*)'*****************'
C ----------------------------------------------------------------------
C SPOSTAM NODI
53    FORMAT(1I4,2X,2E15.5) 
    	
      WRITE(NFOUT,*)'SPOSTAMENTI NODALI'
      WRITE(NFOUT,*)'------------------ '
      WRITE(NFOUT,*)'  N        UX            VY '
      WRITE(NFOUT,*)' '
C
      DO 27 I=1,NNODI
	  NEQX=I*2-1
	  NEQY=I*2
      WRITE(NFOUT,53) I, F(NEQX), F(NEQY)
27    CONTINUE 
C
C ----------------------------------------------------------------------
      WRITE(NFOUT,*)' '
      WRITE(NFOUT,*)' '
C ----------------------------------------------------------------------
      DO 150 I1=1,4
      DO 151 I2=1,16
      DO 152 I3=1,MAXELE
      DEFORMAZIONI(I1,I2,I3)=0.0D0
      TENSIONI    (I1,I2,I3)=0.0D0
152   CONTINUE
151   CONTINUE    
150   CONTINUE              
C ------------------------------------------- ---------------------------
C CALCOLO TENSIONI E DEFORMAZIONI
      WRITE(NFOUT,*)'DEFORMAZIONI E TENSIONI'
      WRITE(NFOUT,*)'----------------------- '
      WRITE(NFOUT,*)'EL   PG  X  Y   EPSX      EPSY       GXY       EPSZ    
     &    SIGX       SIGY        TXY     SIGZ' 
      WRITE(NFOUT,*)' '
      WRITE(NFOUT,*)'EL   PG  X  Y   EPSR      EPSY       GRY       EPST    
     &    SIGR       SIGY        TRY     SIGT'
      WRITE(NFOUT,*)'--------------------------------------------------'
C
      REWIND(NF_B )
      REWIND(NF_CB)
C ---------------------------------------------------------------------
C ---------------------------------------------------------------------
      DO 100 I=1,NELE
C
      NMAT_= IMAT(I)
C
      IPL_STR=I_PL(NMAT_)
	E  = PROP(1,NMAT_)
	XNI= PROP(2,NMAT_)
C
      NTENS=4
      IF(IPL_STR.EQ.1.OR.IPL_STR.EQ.2) NTENS=3
C
C INCIDENZE ELEMENTO CORRENTE I
      NN(1)=INC(1,I)
      NN(2)=INC(2,I)
      NN(3)=INC(3,I)
      NN(4)=INC(4,I)
C
C ESTRAZIONE NUMERO PUNTI REG GAUSS EL I
      NG=NP_G(I)
      CALL GAULEG(-1.D0, +1.D0, XG, WG, NG) 
C
C ELEM 3 NODI HA SEMPRE 1 SOLO PG
      IF(NN(4).EQ.0) NG=1 
C ---------------------------------------------------------------------
C ESTRAGGO COORDINATE GLOBALI NODI DELL'ELEMENTO       
       XYE(1,1)=XYZ(1,INC(1,I))
       XYE(2,1)=XYZ(2,INC(1,I))
       XYE(3,1)=XYZ(3,INC(1,I))
C
       XYE(1,2)=XYZ(1,INC(2,I))
       XYE(2,2)=XYZ(2,INC(2,I))
       XYE(3,2)=XYZ(3,INC(2,I))
C
       XYE(1,3)=XYZ(1,INC(3,I))
       XYE(2,3)=XYZ(2,INC(3,I))
       XYE(3,3)=XYZ(3,INC(3,I))
C
       XYE(1,4)=XYZ(1,INC(4,I))
       XYE(2,4)=XYZ(2,INC(4,I))
       XYE(3,4)=XYZ(3,INC(4,I))
C ---------------------------------------------------------------------
C ESTRAGGO SPOSTAMENTI NODALI DELL'ELEM CORRENTE I DAL VETTORE SOLUZ
      DE(1)=F(2*NN(1)-1)
      DE(2)=F(2*NN(1)  )
C
      DE(3)=F(2*NN(2)-1)
      DE(4)=F(2*NN(2)  )
C
      DE(5)=F(2*NN(3)-1)
      DE(6)=F(2*NN(3)  )
C
      DE(7)=F(2*NN(4)-1)
      DE(8)=F(2*NN(4)  )
C
C ----------------------------------------------------------------------
C 1. ELEMENTO TRIANGOLARE
C 2. ELEMENTO QUADRANGOLARE
C
C CICLO SUI PUNTI DI GAUSS PER L'INTEGRAZIONE
      NPG=0
      DO 40 ICSI=1,NG
	CSI=XG(ICSI)
C
      DO 20 IETA=1,NG
      ETA=XG(IETA)
C
      NPG=NPG+1
C ----------------------------------------------------------------------
C CALCOLO COORD ASSOLUTE PUNTO DI GAUSS
C -----------------
C ELEMENTI A 3 NODI      
	IF(ITE(I).EQ.3)	 THEN
	 XPI=(XYE(1,1)+XYE(1,2)+XYE(1,3))/3.0
	 YPI=(XYE(2,1)+XYE(2,2)+XYE(2,3))/3.0
	 ZPI=(XYE(3,1)+XYE(3,2)+XYE(3,3))/3.0
	ELSE
C -----------------
C ELEMENTI A 4 NODI      
	 CALL FUNZ_FORMA(CSI, ETA )
       XPI=0.0D0
       YPI=0.0D0
       ZPI=0.0D0        
       DO 28 KK=1,4
       XPI=XPI+XN(KK)*XYE(1,KK) 
       YPI=YPI+XN(KK)*XYE(2,KK)
28     ZPI=ZPI+XN(KK)*XYE(3,KK)
      ENDIF
C ----------------------------------------------------------------------
C LETTURA MATR. B E CB DAI FILES BINARI  NF_B e  NF_CB
C    
      NDOF=8
	  IF(NN(4).EQ.0) NDOF=6
C
           READ(NF_B ) (( B (I7,I8),I8=1,NDOF ),I7=1,NTENS)     
           READ(NF_CB) ((CB (I7,I8),I8=1,NDOF ),I7=1,NTENS)     
C -----------------------------------------------------
C CALCOLO DEFORMAZIONI EPS=B * D
      DO 50 II=1,NTENS
	  TEMP=0.0D0
	  DO 67 JJ=1,NDOF
67	  TEMP=TEMP+B(II,JJ)*DE(JJ)
      DEFORMAZIONI(II,NPG,I)=TEMP
50    CONTINUE
C
C CALCOLO TENSIONI  SIG= C * EPS = CB * D
      DO 51 II=1,NTENS
	  TEMP=0.0D0
	  DO 69 JJ=1,NDOF
69	  TEMP=TEMP+CB(II,JJ)*DE(JJ)
      TENSIONI(II,NPG,I)=TEMP
51    CONTINUE
C
C DEFORMAZ EPS_Z PER STATO TENS PIANO
      IF(IPL_STR.EQ.1) THEN
      EPS_Z=-(XNI/E) * (TENSIONI(1,NPG,I)+TENSIONI(2,NPG,I))
      DEFORMAZIONI(4,NPG,I)=EPS_Z
	ENDIF
C
C TENSIONE SIG_Z PER STATO DEFORM PIANO
      IF(IPL_STR.EQ.2) THEN
	EPS_X=DEFORMAZIONI(1,NPG,I)
	EPS_Y=DEFORMAZIONI(2,NPG,I) 
      SIG_Z=(E*XNI)* (EPS_X+EPS_Y) /((1.D0+XNI)*(1.D0-2.D0*XNI))
	TENSIONI(4,NPG,I)=SIG_Z
	ENDIF
C --------------------------------------------------------------
C ESTRAGGO DEF E TENSIONI PER LA STAMPA
C 1. STATO TENS PIANO
      IF(IPL_STR.EQ.1) THEN
      EPSX=DEFORMAZIONI(1,NPG,I)
      EPSY=DEFORMAZIONI(2,NPG,I)
      GXY =DEFORMAZIONI(3,NPG,I)
      EPSZ=DEFORMAZIONI(4,NPG,I)
C
      SIGX=TENSIONI(1,NPG,I)
      SIGY=TENSIONI(2,NPG,I)
      TXY =TENSIONI(3,NPG,I)
      SIGZ=0.0D0
	ENDIF
C --------------------------------------------------------------
C 2. STATO DEF PIANO
      IF(IPL_STR.EQ.2) THEN
      EPSX=DEFORMAZIONI(1,NPG,I)
      EPSY=DEFORMAZIONI(2,NPG,I)
      GXY =DEFORMAZIONI(3,NPG,I)
      EPSZ=0.0D0
C
      SIGX=TENSIONI(1,NPG,I)
      SIGY=TENSIONI(2,NPG,I)
      TXY =TENSIONI(3,NPG,I)
      SIGZ=TENSIONI(4,NPG,I)
	ENDIF
C --------------------------------------------------------------
C CASO ASSIALSIMM: EPSX=EPSR; EPSY=EPSY; GXY=GRY; EPST
      IF(IPL_STR.EQ.3) THEN
      EPSR=DEFORMAZIONI(1,NPG,I)
      EPSY=DEFORMAZIONI(2,NPG,I)
      GRY =DEFORMAZIONI(3,NPG,I)
      EPST=DEFORMAZIONI(4,NPG,I)
C
C CASO ASSIALSIMM: SIGX=SIGR; SIGY=SIGY; TXY=TRY; SIGT
      SIGR=TENSIONI(1,NPG,I)
      SIGY=TENSIONI(2,NPG,I)
      TRY =TENSIONI(3,NPG,I)
      SIGT=TENSIONI(4,NPG,I)
	ENDIF
C --------------------------------------------------------------
C TENS PIANA  
60    FORMAT(1I4,1X,1I3,2F11.4,4E12.4,2X,3E12.4)				
C
C DEF PIANA
61    FORMAT(1I4,1X,1I3,2F11.4,3E12.4,2X,4E12.4)	
C
C STATO ASSIALSIMM
62    FORMAT(1I4,1X,1I3,2F11.4,4E12.4,2X,4E12.4)	
C
C NPL=1 STATO TENSIONALE PIANO
C NPL=2 STATO DEFORMATIVO PIANO
C NPL=3 STATO ASSIALSIMMETRICO
C
      IF(IPL_STR.EQ.1)
     & WRITE(NFOUT,60)
     &           I,NPG, XPI, YPI,EPSX,EPSY,GXY,EPSZ, SIGX,SIGY,TXY
C
      IF(IPL_STR.EQ.2)
     & WRITE(NFOUT,61)
     &           I,NPG, XPI, YPI,EPSX, EPSY, GXY, SIGX, SIGY, TXY, SIGZ
C
      IF(IPL_STR.EQ.3)
     & WRITE(NFOUT,62)
     &           I,NPG, XPI, YPI,EPSR,EPSY,GRY,EPST, SIGR,SIGY,TRY,SIGT
C
20    CONTINUE
40    CONTINUE
C
      WRITE(NFOUT,*) ' '
100   CONTINUE
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C REAZIONI VINCOLARI
C
      WRITE(NFOUT,*) ' '
      WRITE(NFOUT,*)'REAZIONI VINCOLARI'
      WRITE(NFOUT,*)'------------------'
      WRITE(NFOUT,*)'NODO                   RX                       RY'
C
      DO 65 I=1,NNODI
C
      NEQX=2*I-1
      NEQY=2*I
C
      RX=0.0D0
      RY=0.0D0
C -----------------------------------
C 1. SPOSTAMENTI NOTI
C DIR X
      IF(CEDIM(1,I).NE.-9999.) RX=-STIFF*(F(NEQX)-CEDIM(1,I))
C
C DIR Y
      IF(CEDIM(2,I).NE.-9999.) RY=-STIFF*(F(NEQY)-CEDIM(2,I))
C
      GOTO 66
C --------------------------------------
C 2. VINCOLI ELASTICI
C
C MOLLA IN DIR X
C
      IF(RIGID(1,I).NE.0.0D0) RX=-RIGID(1,I)*F(NEQX)
C
C MOLLA IN DIR Y
C
      IF(RIGID(2,I).NE.0.0D0) RY=-RIGID(2,I)*F(NEQY)
C
C --------------------------------------	
C STAMPO LE REAZ VINCOLARI
66    CONTINUE
      IF(RX.NE.0.D0.OR.RY.NE.0.D0) WRITE(NFOUT,*) I, RX, RY
C
65    CONTINUE
C ----------------------------------------------------------------------
      RETURN
      END
C **********************************************************************